You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

Makefile 3.7KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061
  1. # Since we rely on paths relative to the makefile location, abort if make isn't being run from there.
  2. $(if $(findstring /,$(MAKEFILE_LIST)),$(error Please only invoke this makefile from the directory it resides in))
  3. # The files that need updating when incrementing the version number.
  4. VERSIONED_FILES := *.js *.json README*
  5. # Add the local npm packages' bin folder to the PATH, so that `make` can find them, when invoked directly.
  6. # Note that rather than using `$(npm bin)` the 'node_modules/.bin' path component is hard-coded, so that invocation works even from an environment
  7. # where npm is (temporarily) unavailable due to having deactivated an nvm instance loaded into the calling shell in order to avoid interference with tests.
  8. export PATH := $(shell printf '%s' "$$PWD/node_modules/.bin:$$PATH")
  9. UTILS := semver
  10. # Make sure that all required utilities can be located.
  11. UTIL_CHECK := $(or $(shell PATH="$(PATH)" which $(UTILS) >/dev/null && echo 'ok'),$(error Did you forget to run `npm install` after cloning the repo? At least one of the required supporting utilities not found: $(UTILS)))
  12. # Default target (by virtue of being the first non '.'-prefixed in the file).
  13. .PHONY: _no-target-specified
  14. _no-target-specified:
  15. $(error Please specify the target to make - `make list` shows targets. Alternatively, use `npm test` to run the default tests; `npm run` shows all tests)
  16. # Lists all targets defined in this makefile.
  17. .PHONY: list
  18. list:
  19. @$(MAKE) -pRrn : -f $(MAKEFILE_LIST) 2>/dev/null | awk -v RS= -F: '/^# File/,/^# Finished Make data base/ {if ($$1 !~ "^[#.]") {print $$1}}' | command grep -v -e '^[^[:alnum:]]' -e '^$@$$command ' | sort
  20. # All-tests target: invokes the specified test suites for ALL shells defined in $(SHELLS).
  21. .PHONY: test
  22. test:
  23. @npm test
  24. .PHONY: _ensure-tag
  25. _ensure-tag:
  26. ifndef TAG
  27. $(error Please invoke with `make TAG=<new-version> release`, where <new-version> is either an increment specifier (patch, minor, major, prepatch, preminor, premajor, prerelease), or an explicit major.minor.patch version number)
  28. endif
  29. CHANGELOG_ERROR = $(error No CHANGELOG specified)
  30. .PHONY: _ensure-changelog
  31. _ensure-changelog:
  32. @ (git status -sb --porcelain | command grep -E '^( M|[MA] ) CHANGELOG.md' > /dev/null) || (echo no CHANGELOG.md specified && exit 2)
  33. # Ensures that the git workspace is clean.
  34. .PHONY: _ensure-clean
  35. _ensure-clean:
  36. @[ -z "$$((git status --porcelain --untracked-files=no || echo err) | command grep -v 'CHANGELOG.md')" ] || { echo "Workspace is not clean; please commit changes first." >&2; exit 2; }
  37. # Makes a release; invoke with `make TAG=<versionOrIncrementSpec> release`.
  38. .PHONY: release
  39. release: _ensure-tag _ensure-changelog _ensure-clean
  40. @old_ver=`git describe --abbrev=0 --tags --match 'v[0-9]*.[0-9]*.[0-9]*'` || { echo "Failed to determine current version." >&2; exit 1; }; old_ver=$${old_ver#v}; \
  41. new_ver=`echo "$(TAG)" | sed 's/^v//'`; new_ver=$${new_ver:-patch}; \
  42. if printf "$$new_ver" | command grep -q '^[0-9]'; then \
  43. semver "$$new_ver" >/dev/null || { echo 'Invalid version number specified: $(TAG) - must be major.minor.patch' >&2; exit 2; }; \
  44. semver -r "> $$old_ver" "$$new_ver" >/dev/null || { echo 'Invalid version number specified: $(TAG) - must be HIGHER than current one.' >&2; exit 2; } \
  45. else \
  46. new_ver=`semver -i "$$new_ver" "$$old_ver"` || { echo 'Invalid version-increment specifier: $(TAG)' >&2; exit 2; } \
  47. fi; \
  48. printf "=== Bumping version **$$old_ver** to **$$new_ver** before committing and tagging:\n=== TYPE 'proceed' TO PROCEED, anything else to abort: " && read response && [ "$$response" = 'proceed' ] || { echo 'Aborted.' >&2; exit 2; }; \
  49. replace "$$old_ver" "$$new_ver" -- $(VERSIONED_FILES) && \
  50. git commit -m "v$$new_ver" $(VERSIONED_FILES) CHANGELOG.md && \
  51. git tag -a -m "v$$new_ver" "v$$new_ver"